diff --git a/contrib/__package_zypper/README b/contrib/__package_zypper/README
new file mode 100644
index 00000000..1e073e3f
--- /dev/null
+++ b/contrib/__package_zypper/README
@@ -0,0 +1,5 @@
+This type was not accepted, because cleanups are needed and the
+manpage does not build.
+
+If you read this and want this code available in the cdist core,
+just fix it and submit a git url :-)
diff --git a/contrib/__package_zypper/explorer/pkg_version b/contrib/__package_zypper/explorer/pkg_version
new file mode 100755
index 00000000..0e078f68
--- /dev/null
+++ b/contrib/__package_zypper/explorer/pkg_version
@@ -0,0 +1,30 @@
+#!/bin/sh
+#
+# 2011 Nico Schottelius (nico-cdist at schottelius.org)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+#
+# Retrieve the status of a package - parsed dpkg output
+#
+
+if [ -f "$__object/parameter/name" ]; then
+ name="$(cat "$__object/parameter/name")"
+else
+ name="$__object_id"
+fi
+
+rpm -q --whatprovides "$name" 2>/dev/null || true
diff --git a/contrib/__package_zypper/gencode-remote b/contrib/__package_zypper/gencode-remote
new file mode 100755
index 00000000..2d1112d3
--- /dev/null
+++ b/contrib/__package_zypper/gencode-remote
@@ -0,0 +1,51 @@
+#!/bin/sh
+#
+# 2011 Nico Schottelius (nico-cdist at schottelius.org)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+#
+# Manage packages with yum (mostly Fedora)
+#
+
+if [ -f "$__object/parameter/name" ]; then
+ name="$__object/parameter/name"
+else
+ name="$__object_id"
+fi
+
+state="$(cat "$__object/parameter/state")"
+
+opts="-n -q"
+
+not_installed="^no package provides"
+
+case "$state" in
+ installed)
+ if grep -q "$not_installed" "$__object/explorer/pkg_version"; then
+ echo zypper $opts install \"$name\"
+ fi
+ ;;
+ removed)
+ if ! grep -q "$not_installed" "$__object/explorer/pkg_version"; then
+ echo zypper $opts remove \"$name\"
+ fi
+ ;;
+ *)
+ echo "Unknown state: $state" >&2
+ exit 1
+ ;;
+esac
diff --git a/contrib/__package_zypper/man.text b/contrib/__package_zypper/man.text
new file mode 100644
index 00000000..3a4f1026
--- /dev/null
+++ b/contrib/__package_zypper/man.text
@@ -0,0 +1,52 @@
+cdist-type__package_zypper(7)
+==========================
+Franky Van Liedekerke
+
+
+NAME
+----
+cdist-type__package_zypper - Manage packages with zypper
+
+
+DESCRIPTION
+-----------
+zypper is usually used on the Suse distribution to manage packages.
+
+
+REQUIRED PARAMETERS
+-------------------
+state::
+ Either "installed" or "removed".
+
+
+OPTIONAL PARAMETERS
+-------------------
+name::
+ If supplied, use the name and not the object id as the package name.
+
+
+EXAMPLES
+--------
+
+--------------------------------------------------------------------------------
+# Ensure zsh in installed
+__package_zypper zsh --state installed
+
+# If you don't want to follow pythonX packages, but always use python
+__package_zypper python --state installed --name python2
+
+# Remove obsolete package
+__package_zypper puppet --state removed
+--------------------------------------------------------------------------------
+
+
+SEE ALSO
+--------
+- cdist-type(7)
+- cdist-type__package(7)
+
+
+COPYING
+-------
+Copyright \(C) 2011 Nico Schottelius. Free use of this software is
+granted under the terms of the GNU General Public License version 3 (GPLv3).
diff --git a/contrib/__package_zypper/parameter/optional b/contrib/__package_zypper/parameter/optional
new file mode 100644
index 00000000..f121bdbf
--- /dev/null
+++ b/contrib/__package_zypper/parameter/optional
@@ -0,0 +1 @@
+name
diff --git a/contrib/__package_zypper/parameter/required b/contrib/__package_zypper/parameter/required
new file mode 100644
index 00000000..ff72b5c7
--- /dev/null
+++ b/contrib/__package_zypper/parameter/required
@@ -0,0 +1 @@
+state